/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * XCore Disassembler                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static void insertBits(InsnType &field, InsnType bits, unsigned startBit,
                       unsigned numBits) {
  if constexpr (std::is_integral<InsnType>::value) {
    assert(startBit + numBits <= sizeof field * 8);
    (void)numBits;
    field |= (InsnType)bits << startBit;
  } else {
    field.insertBits(bits, startBit, numBits);
  }
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTable16[] = {
/* 0 */       MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 3 */       MCD::OPC_FilterValue, 0, 117, 0, // Skip to: 124
/* 7 */       MCD::OPC_ExtractField, 0, 11,  // Inst{10-0} ...
/* 10 */      MCD::OPC_FilterValue, 236, 15, 4, 0, // Skip to: 19
/* 15 */      MCD::OPC_Decode, 146, 4, 0, // Opcode: WAITEU_0R
/* 19 */      MCD::OPC_FilterValue, 237, 15, 4, 0, // Skip to: 28
/* 24 */      MCD::OPC_Decode, 225, 2, 0, // Opcode: CLRE_0R
/* 28 */      MCD::OPC_FilterValue, 238, 15, 4, 0, // Skip to: 37
/* 33 */      MCD::OPC_Decode, 250, 3, 0, // Opcode: SSYNC_0r
/* 37 */      MCD::OPC_FilterValue, 239, 15, 4, 0, // Skip to: 46
/* 42 */      MCD::OPC_Decode, 129, 3, 0, // Opcode: FREET_0R
/* 46 */      MCD::OPC_FilterValue, 252, 15, 4, 0, // Skip to: 55
/* 51 */      MCD::OPC_Decode, 234, 2, 0, // Opcode: DCALL_0R
/* 55 */      MCD::OPC_FilterValue, 253, 15, 4, 0, // Skip to: 64
/* 60 */      MCD::OPC_Decode, 160, 3, 0, // Opcode: KRET_0R
/* 64 */      MCD::OPC_FilterValue, 254, 15, 4, 0, // Skip to: 73
/* 69 */      MCD::OPC_Decode, 240, 2, 0, // Opcode: DRET_0R
/* 73 */      MCD::OPC_FilterValue, 255, 15, 4, 0, // Skip to: 82
/* 78 */      MCD::OPC_Decode, 231, 3, 0, // Opcode: SETKEP_0R
/* 82 */      MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 85 */      MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 93
/* 89 */      MCD::OPC_Decode, 243, 2, 1, // Opcode: EDU_1r
/* 93 */      MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 101
/* 97 */      MCD::OPC_Decode, 246, 2, 1, // Opcode: EEU_1r
/* 101 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 104 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 112
/* 108 */     MCD::OPC_Decode, 147, 3, 2, // Opcode: INITPC_2r
/* 112 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 120
/* 116 */     MCD::OPC_Decode, 141, 3, 2, // Opcode: GETST_2r
/* 120 */     MCD::OPC_Decode, 133, 4, 3, // Opcode: STW_2rus
/* 124 */     MCD::OPC_FilterValue, 1, 117, 0, // Skip to: 245
/* 128 */     MCD::OPC_ExtractField, 0, 11,  // Inst{10-0} ...
/* 131 */     MCD::OPC_FilterValue, 236, 15, 4, 0, // Skip to: 140
/* 136 */     MCD::OPC_Decode, 186, 3, 0, // Opcode: LDSPC_0R
/* 140 */     MCD::OPC_FilterValue, 237, 15, 4, 0, // Skip to: 149
/* 145 */     MCD::OPC_Decode, 255, 3, 0, // Opcode: STSPC_0R
/* 149 */     MCD::OPC_FilterValue, 238, 15, 4, 0, // Skip to: 158
/* 154 */     MCD::OPC_Decode, 187, 3, 0, // Opcode: LDSSR_0R
/* 158 */     MCD::OPC_FilterValue, 239, 15, 4, 0, // Skip to: 167
/* 163 */     MCD::OPC_Decode, 128, 4, 0, // Opcode: STSSR_0R
/* 167 */     MCD::OPC_FilterValue, 252, 15, 4, 0, // Skip to: 176
/* 172 */     MCD::OPC_Decode, 254, 3, 0, // Opcode: STSED_0R
/* 176 */     MCD::OPC_FilterValue, 253, 15, 4, 0, // Skip to: 185
/* 181 */     MCD::OPC_Decode, 253, 3, 0, // Opcode: STET_0R
/* 185 */     MCD::OPC_FilterValue, 254, 15, 4, 0, // Skip to: 194
/* 190 */     MCD::OPC_Decode, 131, 3, 0, // Opcode: GETED_0R
/* 194 */     MCD::OPC_FilterValue, 255, 15, 4, 0, // Skip to: 203
/* 199 */     MCD::OPC_Decode, 132, 3, 0, // Opcode: GETET_0R
/* 203 */     MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 206 */     MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 214
/* 210 */     MCD::OPC_Decode, 145, 4, 1, // Opcode: WAITET_1R
/* 214 */     MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 222
/* 218 */     MCD::OPC_Decode, 144, 4, 1, // Opcode: WAITEF_1R
/* 222 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 225 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 233
/* 229 */     MCD::OPC_Decode, 145, 3, 2, // Opcode: INITDP_2r
/* 233 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 241
/* 237 */     MCD::OPC_Decode, 216, 3, 4, // Opcode: OUTT_2r
/* 241 */     MCD::OPC_Decode, 196, 3, 3, // Opcode: LDW_2rus
/* 245 */     MCD::OPC_FilterValue, 2, 108, 0, // Skip to: 357
/* 249 */     MCD::OPC_ExtractField, 0, 11,  // Inst{10-0} ...
/* 252 */     MCD::OPC_FilterValue, 236, 15, 4, 0, // Skip to: 261
/* 257 */     MCD::OPC_Decode, 235, 2, 0, // Opcode: DENTSP_0R
/* 261 */     MCD::OPC_FilterValue, 237, 15, 4, 0, // Skip to: 270
/* 266 */     MCD::OPC_Decode, 239, 2, 0, // Opcode: DRESTSP_0R
/* 270 */     MCD::OPC_FilterValue, 238, 15, 4, 0, // Skip to: 279
/* 275 */     MCD::OPC_Decode, 133, 3, 0, // Opcode: GETID_0R
/* 279 */     MCD::OPC_FilterValue, 239, 15, 4, 0, // Skip to: 288
/* 284 */     MCD::OPC_Decode, 134, 3, 0, // Opcode: GETKEP_0R
/* 288 */     MCD::OPC_FilterValue, 252, 15, 4, 0, // Skip to: 297
/* 293 */     MCD::OPC_Decode, 135, 3, 0, // Opcode: GETKSP_0R
/* 297 */     MCD::OPC_FilterValue, 253, 15, 4, 0, // Skip to: 306
/* 302 */     MCD::OPC_Decode, 185, 3, 0, // Opcode: LDSED_0R
/* 306 */     MCD::OPC_FilterValue, 254, 15, 4, 0, // Skip to: 315
/* 311 */     MCD::OPC_Decode, 183, 3, 0, // Opcode: LDET_0R
/* 315 */     MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 318 */     MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 326
/* 322 */     MCD::OPC_Decode, 128, 3, 1, // Opcode: FREER_1r
/* 326 */     MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 334
/* 330 */     MCD::OPC_Decode, 204, 3, 1, // Opcode: MJOIN_1r
/* 334 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 337 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 345
/* 341 */     MCD::OPC_Decode, 148, 3, 2, // Opcode: INITSP_2r
/* 345 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 353
/* 349 */     MCD::OPC_Decode, 229, 3, 4, // Opcode: SETD_2r
/* 353 */     MCD::OPC_Decode, 193, 2, 5, // Opcode: ADD_3r
/* 357 */     MCD::OPC_FilterValue, 3, 42, 0, // Skip to: 403
/* 361 */     MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 364 */     MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 372
/* 368 */     MCD::OPC_Decode, 143, 4, 1, // Opcode: TSTART_1R
/* 372 */     MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 380
/* 376 */     MCD::OPC_Decode, 207, 3, 1, // Opcode: MSYNC_1r
/* 380 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 383 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 391
/* 387 */     MCD::OPC_Decode, 144, 3, 2, // Opcode: INITCP_2r
/* 391 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 399
/* 395 */     MCD::OPC_Decode, 141, 4, 6, // Opcode: TSETMR_2r
/* 399 */     MCD::OPC_Decode, 136, 4, 5, // Opcode: SUB_3r
/* 403 */     MCD::OPC_FilterValue, 4, 33, 0, // Skip to: 440
/* 407 */     MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 410 */     MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 418
/* 414 */     MCD::OPC_Decode, 204, 2, 1, // Opcode: BLA_1r
/* 418 */     MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 426
/* 422 */     MCD::OPC_Decode, 198, 2, 1, // Opcode: BAU_1r
/* 426 */     MCD::OPC_CheckField, 4, 1, 1, 4, 0, // Skip to: 436
/* 432 */     MCD::OPC_Decode, 245, 2, 2, // Opcode: EET_2r
/* 436 */     MCD::OPC_Decode, 247, 3, 5, // Opcode: SHL_3r
/* 440 */     MCD::OPC_FilterValue, 5, 42, 0, // Skip to: 486
/* 444 */     MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 447 */     MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 455
/* 451 */     MCD::OPC_Decode, 221, 2, 1, // Opcode: BRU_1r
/* 455 */     MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 463
/* 459 */     MCD::OPC_Decode, 237, 3, 1, // Opcode: SETSP_1r
/* 463 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 466 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 474
/* 470 */     MCD::OPC_Decode, 194, 2, 7, // Opcode: ANDNOT_2r
/* 474 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 482
/* 478 */     MCD::OPC_Decode, 244, 2, 2, // Opcode: EEF_2r
/* 482 */     MCD::OPC_Decode, 249, 3, 5, // Opcode: SHR_3r
/* 486 */     MCD::OPC_FilterValue, 6, 42, 0, // Skip to: 532
/* 490 */     MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 493 */     MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 501
/* 497 */     MCD::OPC_Decode, 228, 3, 1, // Opcode: SETDP_1r
/* 501 */     MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 509
/* 505 */     MCD::OPC_Decode, 224, 3, 1, // Opcode: SETCP_1r
/* 509 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 512 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 520
/* 516 */     MCD::OPC_Decode, 244, 3, 7, // Opcode: SEXT_2r
/* 520 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 528
/* 524 */     MCD::OPC_Decode, 245, 3, 8, // Opcode: SEXT_rus
/* 528 */     MCD::OPC_Decode, 251, 2, 5, // Opcode: EQ_3r
/* 532 */     MCD::OPC_FilterValue, 7, 42, 0, // Skip to: 578
/* 536 */     MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 539 */     MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 547
/* 543 */     MCD::OPC_Decode, 236, 2, 1, // Opcode: DGETREG_1r
/* 547 */     MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 555
/* 551 */     MCD::OPC_Decode, 230, 3, 1, // Opcode: SETEV_1r
/* 555 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 558 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 566
/* 562 */     MCD::OPC_Decode, 142, 3, 2, // Opcode: GETTS_2r
/* 566 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 574
/* 570 */     MCD::OPC_Decode, 235, 3, 4, // Opcode: SETPT_2r
/* 574 */     MCD::OPC_Decode, 195, 2, 5, // Opcode: AND_3r
/* 578 */     MCD::OPC_FilterValue, 8, 42, 0, // Skip to: 624
/* 582 */     MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 585 */     MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 593
/* 589 */     MCD::OPC_Decode, 153, 3, 1, // Opcode: KCALL_1r
/* 593 */     MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 601
/* 597 */     MCD::OPC_Decode, 243, 3, 1, // Opcode: SETV_1r
/* 601 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 604 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 612
/* 608 */     MCD::OPC_Decode, 148, 4, 7, // Opcode: ZEXT_2r
/* 612 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 620
/* 616 */     MCD::OPC_Decode, 149, 4, 8, // Opcode: ZEXT_rus
/* 620 */     MCD::OPC_Decode, 211, 3, 5, // Opcode: OR_3r
/* 624 */     MCD::OPC_FilterValue, 9, 42, 0, // Skip to: 670
/* 628 */     MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 631 */     MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 639
/* 635 */     MCD::OPC_Decode, 241, 2, 1, // Opcode: ECALLF_1r
/* 639 */     MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 647
/* 643 */     MCD::OPC_Decode, 242, 2, 1, // Opcode: ECALLT_1r
/* 647 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 650 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 658
/* 654 */     MCD::OPC_Decode, 212, 3, 2, // Opcode: OUTCT_2r
/* 658 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 666
/* 662 */     MCD::OPC_Decode, 213, 3, 9, // Opcode: OUTCT_rus
/* 666 */     MCD::OPC_Decode, 197, 3, 5, // Opcode: LDW_3r
/* 670 */     MCD::OPC_FilterValue, 10, 19, 0, // Skip to: 693
/* 674 */     MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 677 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 685
/* 681 */     MCD::OPC_Decode, 130, 4, 10, // Opcode: STWDP_ru6
/* 685 */     MCD::OPC_FilterValue, 1, 84, 2, // Skip to: 1285
/* 689 */     MCD::OPC_Decode, 132, 4, 10, // Opcode: STWSP_ru6
/* 693 */     MCD::OPC_FilterValue, 11, 19, 0, // Skip to: 716
/* 697 */     MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 700 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 708
/* 704 */     MCD::OPC_Decode, 193, 3, 10, // Opcode: LDWDP_ru6
/* 708 */     MCD::OPC_FilterValue, 1, 61, 2, // Skip to: 1285
/* 712 */     MCD::OPC_Decode, 195, 3, 10, // Opcode: LDWSP_ru6
/* 716 */     MCD::OPC_FilterValue, 12, 19, 0, // Skip to: 739
/* 720 */     MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 723 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 731
/* 727 */     MCD::OPC_Decode, 176, 3, 10, // Opcode: LDAWDP_ru6
/* 731 */     MCD::OPC_FilterValue, 1, 38, 2, // Skip to: 1285
/* 735 */     MCD::OPC_Decode, 180, 3, 10, // Opcode: LDAWSP_ru6
/* 739 */     MCD::OPC_FilterValue, 13, 19, 0, // Skip to: 762
/* 743 */     MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 746 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 754
/* 750 */     MCD::OPC_Decode, 182, 3, 10, // Opcode: LDC_ru6
/* 754 */     MCD::OPC_FilterValue, 1, 15, 2, // Skip to: 1285
/* 758 */     MCD::OPC_Decode, 190, 3, 10, // Opcode: LDWCP_ru6
/* 762 */     MCD::OPC_FilterValue, 14, 89, 0, // Skip to: 855
/* 766 */     MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 769 */     MCD::OPC_FilterValue, 0, 39, 0, // Skip to: 812
/* 773 */     MCD::OPC_ExtractField, 6, 4,  // Inst{9-6} ...
/* 776 */     MCD::OPC_FilterValue, 12, 4, 0, // Skip to: 784
/* 780 */     MCD::OPC_Decode, 220, 2, 11, // Opcode: BRFU_u6
/* 784 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 792
/* 788 */     MCD::OPC_Decode, 203, 2, 11, // Opcode: BLAT_u6
/* 792 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 800
/* 796 */     MCD::OPC_Decode, 253, 2, 11, // Opcode: EXTDP_u6
/* 800 */     MCD::OPC_FilterValue, 15, 4, 0, // Skip to: 808
/* 804 */     MCD::OPC_Decode, 155, 3, 11, // Opcode: KCALL_u6
/* 808 */     MCD::OPC_Decode, 218, 2, 12, // Opcode: BRFT_ru6
/* 812 */     MCD::OPC_FilterValue, 1, 213, 1, // Skip to: 1285
/* 816 */     MCD::OPC_ExtractField, 6, 4,  // Inst{9-6} ...
/* 819 */     MCD::OPC_FilterValue, 12, 4, 0, // Skip to: 827
/* 823 */     MCD::OPC_Decode, 214, 2, 13, // Opcode: BRBU_u6
/* 827 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 835
/* 831 */     MCD::OPC_Decode, 249, 2, 11, // Opcode: ENTSP_u6
/* 835 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 843
/* 839 */     MCD::OPC_Decode, 255, 2, 11, // Opcode: EXTSP_u6
/* 843 */     MCD::OPC_FilterValue, 15, 4, 0, // Skip to: 851
/* 847 */     MCD::OPC_Decode, 222, 3, 11, // Opcode: RETSP_u6
/* 851 */     MCD::OPC_Decode, 212, 2, 14, // Opcode: BRBT_ru6
/* 855 */     MCD::OPC_FilterValue, 15, 73, 0, // Skip to: 932
/* 859 */     MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 862 */     MCD::OPC_FilterValue, 0, 39, 0, // Skip to: 905
/* 866 */     MCD::OPC_ExtractField, 6, 4,  // Inst{9-6} ...
/* 869 */     MCD::OPC_FilterValue, 12, 4, 0, // Skip to: 877
/* 873 */     MCD::OPC_Decode, 230, 2, 11, // Opcode: CLRSR_u6
/* 877 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 885
/* 881 */     MCD::OPC_Decode, 241, 3, 11, // Opcode: SETSR_u6
/* 885 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 893
/* 889 */     MCD::OPC_Decode, 157, 3, 11, // Opcode: KENTSP_u6
/* 893 */     MCD::OPC_FilterValue, 15, 4, 0, // Skip to: 901
/* 897 */     MCD::OPC_Decode, 159, 3, 11, // Opcode: KRESTSP_u6
/* 901 */     MCD::OPC_Decode, 216, 2, 12, // Opcode: BRFF_ru6
/* 905 */     MCD::OPC_FilterValue, 1, 120, 1, // Skip to: 1285
/* 909 */     MCD::OPC_ExtractField, 6, 4,  // Inst{9-6} ...
/* 912 */     MCD::OPC_FilterValue, 12, 4, 0, // Skip to: 920
/* 916 */     MCD::OPC_Decode, 140, 3, 11, // Opcode: GETSR_u6
/* 920 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 928
/* 924 */     MCD::OPC_Decode, 174, 3, 11, // Opcode: LDAWCP_u6
/* 928 */     MCD::OPC_Decode, 210, 2, 14, // Opcode: BRBF_ru6
/* 932 */     MCD::OPC_FilterValue, 16, 42, 0, // Skip to: 978
/* 936 */     MCD::OPC_ExtractField, 4, 7,  // Inst{10-4} ...
/* 939 */     MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 947
/* 943 */     MCD::OPC_Decode, 226, 2, 1, // Opcode: CLRPT_1R
/* 947 */     MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 955
/* 951 */     MCD::OPC_Decode, 137, 4, 1, // Opcode: SYNCR_1r
/* 955 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 958 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 966
/* 962 */     MCD::OPC_Decode, 138, 3, 9, // Opcode: GETR_rus
/* 966 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 974
/* 970 */     MCD::OPC_Decode, 143, 3, 2, // Opcode: INCT_2r
/* 974 */     MCD::OPC_Decode, 162, 3, 5, // Opcode: LD16S_3r
/* 978 */     MCD::OPC_FilterValue, 17, 23, 0, // Skip to: 1005
/* 982 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 985 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 993
/* 989 */     MCD::OPC_Decode, 210, 3, 2, // Opcode: NOT
/* 993 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1001
/* 997 */     MCD::OPC_Decode, 151, 3, 2, // Opcode: INT_2r
/* 1001 */    MCD::OPC_Decode, 163, 3, 5, // Opcode: LD8U_3r
/* 1005 */    MCD::OPC_FilterValue, 18, 23, 0, // Skip to: 1032
/* 1009 */    MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 1012 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1020
/* 1016 */    MCD::OPC_Decode, 209, 3, 2, // Opcode: NEG
/* 1020 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1028
/* 1024 */    MCD::OPC_Decode, 247, 2, 2, // Opcode: ENDIN_2r
/* 1028 */    MCD::OPC_Decode, 192, 2, 3, // Opcode: ADD_2rus
/* 1032 */    MCD::OPC_FilterValue, 19, 4, 0, // Skip to: 1040
/* 1036 */    MCD::OPC_Decode, 135, 4, 3, // Opcode: SUB_2rus
/* 1040 */    MCD::OPC_FilterValue, 20, 23, 0, // Skip to: 1067
/* 1044 */    MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 1047 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1055
/* 1051 */    MCD::OPC_Decode, 205, 3, 2, // Opcode: MKMSK_2r
/* 1055 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1063
/* 1059 */    MCD::OPC_Decode, 206, 3, 15, // Opcode: MKMSK_rus
/* 1063 */    MCD::OPC_Decode, 246, 3, 16, // Opcode: SHL_2rus
/* 1067 */    MCD::OPC_FilterValue, 21, 23, 0, // Skip to: 1094
/* 1071 */    MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 1074 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1082
/* 1078 */    MCD::OPC_Decode, 217, 3, 4, // Opcode: OUT_2r
/* 1082 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1090
/* 1086 */    MCD::OPC_Decode, 215, 3, 7, // Opcode: OUTSHR_2r
/* 1090 */    MCD::OPC_Decode, 248, 3, 16, // Opcode: SHR_2rus
/* 1094 */    MCD::OPC_FilterValue, 22, 23, 0, // Skip to: 1121
/* 1098 */    MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 1101 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1109
/* 1105 */    MCD::OPC_Decode, 152, 3, 2, // Opcode: IN_2r
/* 1109 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1117
/* 1113 */    MCD::OPC_Decode, 150, 3, 7, // Opcode: INSHR_2r
/* 1117 */    MCD::OPC_Decode, 250, 2, 3, // Opcode: EQ_2rus
/* 1121 */    MCD::OPC_FilterValue, 23, 23, 0, // Skip to: 1148
/* 1125 */    MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 1128 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1136
/* 1132 */    MCD::OPC_Decode, 218, 3, 2, // Opcode: PEEK_2r
/* 1136 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1144
/* 1140 */    MCD::OPC_Decode, 138, 4, 2, // Opcode: TESTCT_2r
/* 1144 */    MCD::OPC_Decode, 142, 4, 17, // Opcode: TSETR_3r
/* 1148 */    MCD::OPC_FilterValue, 24, 23, 0, // Skip to: 1175
/* 1152 */    MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 1155 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1163
/* 1159 */    MCD::OPC_Decode, 233, 3, 4, // Opcode: SETPSC_2r
/* 1163 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1171
/* 1167 */    MCD::OPC_Decode, 140, 4, 2, // Opcode: TESTWCT_2r
/* 1171 */    MCD::OPC_Decode, 199, 3, 5, // Opcode: LSS_3r
/* 1175 */    MCD::OPC_FilterValue, 25, 23, 0, // Skip to: 1202
/* 1179 */    MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 1182 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1190
/* 1186 */    MCD::OPC_Decode, 223, 2, 2, // Opcode: CHKCT_2r
/* 1190 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1198
/* 1194 */    MCD::OPC_Decode, 224, 2, 15, // Opcode: CHKCT_rus
/* 1198 */    MCD::OPC_Decode, 201, 3, 5, // Opcode: LSU_3r
/* 1202 */    MCD::OPC_FilterValue, 26, 19, 0, // Skip to: 1225
/* 1206 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 1209 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1217
/* 1213 */    MCD::OPC_Decode, 208, 2, 18, // Opcode: BLRF_u10
/* 1217 */    MCD::OPC_FilterValue, 1, 64, 0, // Skip to: 1285
/* 1221 */    MCD::OPC_Decode, 206, 2, 19, // Opcode: BLRB_u10
/* 1225 */    MCD::OPC_FilterValue, 27, 19, 0, // Skip to: 1248
/* 1229 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 1232 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1240
/* 1236 */    MCD::OPC_Decode, 170, 3, 18, // Opcode: LDAPF_u10
/* 1240 */    MCD::OPC_FilterValue, 1, 41, 0, // Skip to: 1285
/* 1244 */    MCD::OPC_Decode, 167, 3, 19, // Opcode: LDAPB_u10
/* 1248 */    MCD::OPC_FilterValue, 28, 19, 0, // Skip to: 1271
/* 1252 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 1255 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1263
/* 1259 */    MCD::OPC_Decode, 201, 2, 18, // Opcode: BLACP_u10
/* 1263 */    MCD::OPC_FilterValue, 1, 18, 0, // Skip to: 1285
/* 1267 */    MCD::OPC_Decode, 191, 3, 18, // Opcode: LDWCP_u10
/* 1271 */    MCD::OPC_FilterValue, 29, 10, 0, // Skip to: 1285
/* 1275 */    MCD::OPC_CheckField, 10, 1, 0, 4, 0, // Skip to: 1285
/* 1281 */    MCD::OPC_Decode, 227, 3, 12, // Opcode: SETC_ru6
/* 1285 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTable32[] = {
/* 0 */       MCD::OPC_ExtractField, 27, 5,  // Inst{31-27} ...
/* 3 */       MCD::OPC_FilterValue, 0, 93, 0, // Skip to: 100
/* 7 */       MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 10 */      MCD::OPC_FilterValue, 31, 249, 3, // Skip to: 1031
/* 14 */      MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 17 */      MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 32
/* 21 */      MCD::OPC_CheckField, 16, 11, 236, 15, 19, 0, // Skip to: 47
/* 28 */      MCD::OPC_Decode, 199, 2, 20, // Opcode: BITREV_l2r
/* 32 */      MCD::OPC_FilterValue, 1, 11, 0, // Skip to: 47
/* 36 */      MCD::OPC_CheckField, 16, 11, 236, 15, 4, 0, // Skip to: 47
/* 43 */      MCD::OPC_Decode, 222, 2, 20, // Opcode: BYTEREV_l2r
/* 47 */      MCD::OPC_CheckField, 16, 11, 236, 15, 4, 0, // Skip to: 58
/* 54 */      MCD::OPC_Decode, 134, 4, 21, // Opcode: STW_l3r
/* 58 */      MCD::OPC_ExtractField, 20, 7,  // Inst{26-20} ...
/* 61 */      MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 69
/* 65 */      MCD::OPC_Decode, 232, 2, 22, // Opcode: CRC8_l4r
/* 69 */      MCD::OPC_FilterValue, 127, 4, 0, // Skip to: 77
/* 73 */      MCD::OPC_Decode, 203, 3, 23, // Opcode: MACCU_l4r
/* 77 */      MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 80 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 88
/* 84 */      MCD::OPC_Decode, 184, 3, 24, // Opcode: LDIVU_l5r
/* 88 */      MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 96
/* 92 */      MCD::OPC_Decode, 161, 3, 24, // Opcode: LADD_l5r
/* 96 */      MCD::OPC_Decode, 198, 3, 25, // Opcode: LMUL_l6r
/* 100 */     MCD::OPC_FilterValue, 1, 87, 0, // Skip to: 191
/* 104 */     MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 107 */     MCD::OPC_FilterValue, 31, 152, 3, // Skip to: 1031
/* 111 */     MCD::OPC_ExtractField, 20, 1,  // Inst{20} ...
/* 114 */     MCD::OPC_FilterValue, 0, 145, 3, // Skip to: 1031
/* 118 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 121 */     MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 141
/* 125 */     MCD::OPC_CheckField, 21, 6, 63, 30, 0, // Skip to: 161
/* 131 */     MCD::OPC_CheckField, 16, 4, 12, 24, 0, // Skip to: 161
/* 137 */     MCD::OPC_Decode, 231, 2, 20, // Opcode: CLZ_l2r
/* 141 */     MCD::OPC_FilterValue, 1, 16, 0, // Skip to: 161
/* 145 */     MCD::OPC_CheckField, 21, 6, 63, 10, 0, // Skip to: 161
/* 151 */     MCD::OPC_CheckField, 16, 4, 12, 4, 0, // Skip to: 161
/* 157 */     MCD::OPC_Decode, 223, 3, 26, // Opcode: SETCLK_l2r
/* 161 */     MCD::OPC_CheckField, 21, 6, 63, 10, 0, // Skip to: 177
/* 167 */     MCD::OPC_CheckField, 16, 4, 12, 4, 0, // Skip to: 177
/* 173 */     MCD::OPC_Decode, 147, 4, 21, // Opcode: XOR_l3r
/* 177 */     MCD::OPC_CheckField, 21, 6, 63, 4, 0, // Skip to: 187
/* 183 */     MCD::OPC_Decode, 202, 3, 23, // Opcode: MACCS_l4r
/* 187 */     MCD::OPC_Decode, 200, 3, 24, // Opcode: LSUB_l5r
/* 191 */     MCD::OPC_FilterValue, 2, 32, 0, // Skip to: 227
/* 195 */     MCD::OPC_ExtractField, 11, 16,  // Inst{26-11} ...
/* 198 */     MCD::OPC_FilterValue, 159, 251, 3, 59, 3, // Skip to: 1031
/* 204 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 207 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 215
/* 211 */     MCD::OPC_Decode, 146, 3, 20, // Opcode: INITLR_l2r
/* 215 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 223
/* 219 */     MCD::OPC_Decode, 137, 3, 20, // Opcode: GETPS_l2r
/* 223 */     MCD::OPC_Decode, 197, 2, 21, // Opcode: ASHR_l3r
/* 227 */     MCD::OPC_FilterValue, 3, 32, 0, // Skip to: 263
/* 231 */     MCD::OPC_ExtractField, 11, 16,  // Inst{26-11} ...
/* 234 */     MCD::OPC_FilterValue, 159, 251, 3, 23, 3, // Skip to: 1031
/* 240 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 243 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 251
/* 247 */     MCD::OPC_Decode, 234, 3, 26, // Opcode: SETPS_l2r
/* 251 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 259
/* 255 */     MCD::OPC_Decode, 130, 3, 20, // Opcode: GETD_l2r
/* 259 */     MCD::OPC_Decode, 178, 3, 21, // Opcode: LDAWF_l3r
/* 263 */     MCD::OPC_FilterValue, 4, 32, 0, // Skip to: 299
/* 267 */     MCD::OPC_ExtractField, 11, 16,  // Inst{26-11} ...
/* 270 */     MCD::OPC_FilterValue, 159, 251, 3, 243, 2, // Skip to: 1031
/* 276 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 279 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 287
/* 283 */     MCD::OPC_Decode, 139, 4, 20, // Opcode: TESTLCL_l2r
/* 287 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 295
/* 291 */     MCD::OPC_Decode, 242, 3, 26, // Opcode: SETTW_l2r
/* 295 */     MCD::OPC_Decode, 172, 3, 21, // Opcode: LDAWB_l3r
/* 299 */     MCD::OPC_FilterValue, 5, 32, 0, // Skip to: 335
/* 303 */     MCD::OPC_ExtractField, 11, 16,  // Inst{26-11} ...
/* 306 */     MCD::OPC_FilterValue, 159, 251, 3, 207, 2, // Skip to: 1031
/* 312 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 315 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 323
/* 319 */     MCD::OPC_Decode, 236, 3, 26, // Opcode: SETRDY_l2r
/* 323 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 331
/* 327 */     MCD::OPC_Decode, 225, 3, 20, // Opcode: SETC_l2r
/* 331 */     MCD::OPC_Decode, 165, 3, 21, // Opcode: LDA16F_l3r
/* 335 */     MCD::OPC_FilterValue, 6, 32, 0, // Skip to: 371
/* 339 */     MCD::OPC_ExtractField, 11, 16,  // Inst{26-11} ...
/* 342 */     MCD::OPC_FilterValue, 159, 251, 3, 171, 2, // Skip to: 1031
/* 348 */     MCD::OPC_ExtractField, 4, 1,  // Inst{4} ...
/* 351 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 359
/* 355 */     MCD::OPC_Decode, 232, 3, 26, // Opcode: SETN_l2r
/* 359 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 367
/* 363 */     MCD::OPC_Decode, 136, 3, 20, // Opcode: GETN_l2r
/* 367 */     MCD::OPC_Decode, 164, 3, 21, // Opcode: LDA16B_l3r
/* 371 */     MCD::OPC_FilterValue, 7, 12, 0, // Skip to: 387
/* 375 */     MCD::OPC_CheckField, 11, 16, 159, 251, 3, 136, 2, // Skip to: 1031
/* 383 */     MCD::OPC_Decode, 208, 3, 21, // Opcode: MUL_l3r
/* 387 */     MCD::OPC_FilterValue, 8, 12, 0, // Skip to: 403
/* 391 */     MCD::OPC_CheckField, 11, 16, 159, 251, 3, 120, 2, // Skip to: 1031
/* 399 */     MCD::OPC_Decode, 237, 2, 21, // Opcode: DIVS_l3r
/* 403 */     MCD::OPC_FilterValue, 9, 12, 0, // Skip to: 419
/* 407 */     MCD::OPC_CheckField, 11, 16, 159, 251, 3, 104, 2, // Skip to: 1031
/* 415 */     MCD::OPC_Decode, 238, 2, 21, // Opcode: DIVU_l3r
/* 419 */     MCD::OPC_FilterValue, 10, 31, 0, // Skip to: 454
/* 423 */     MCD::OPC_ExtractField, 26, 1,  // Inst{26} ...
/* 426 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 440
/* 430 */     MCD::OPC_CheckField, 10, 6, 60, 83, 2, // Skip to: 1031
/* 436 */     MCD::OPC_Decode, 129, 4, 27, // Opcode: STWDP_lru6
/* 440 */     MCD::OPC_FilterValue, 1, 75, 2, // Skip to: 1031
/* 444 */     MCD::OPC_CheckField, 10, 6, 60, 69, 2, // Skip to: 1031
/* 450 */     MCD::OPC_Decode, 131, 4, 27, // Opcode: STWSP_lru6
/* 454 */     MCD::OPC_FilterValue, 11, 31, 0, // Skip to: 489
/* 458 */     MCD::OPC_ExtractField, 26, 1,  // Inst{26} ...
/* 461 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 475
/* 465 */     MCD::OPC_CheckField, 10, 6, 60, 48, 2, // Skip to: 1031
/* 471 */     MCD::OPC_Decode, 192, 3, 27, // Opcode: LDWDP_lru6
/* 475 */     MCD::OPC_FilterValue, 1, 40, 2, // Skip to: 1031
/* 479 */     MCD::OPC_CheckField, 10, 6, 60, 34, 2, // Skip to: 1031
/* 485 */     MCD::OPC_Decode, 194, 3, 27, // Opcode: LDWSP_lru6
/* 489 */     MCD::OPC_FilterValue, 12, 31, 0, // Skip to: 524
/* 493 */     MCD::OPC_ExtractField, 26, 1,  // Inst{26} ...
/* 496 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 510
/* 500 */     MCD::OPC_CheckField, 10, 6, 60, 13, 2, // Skip to: 1031
/* 506 */     MCD::OPC_Decode, 175, 3, 27, // Opcode: LDAWDP_lru6
/* 510 */     MCD::OPC_FilterValue, 1, 5, 2, // Skip to: 1031
/* 514 */     MCD::OPC_CheckField, 10, 6, 60, 255, 1, // Skip to: 1031
/* 520 */     MCD::OPC_Decode, 179, 3, 27, // Opcode: LDAWSP_lru6
/* 524 */     MCD::OPC_FilterValue, 13, 31, 0, // Skip to: 559
/* 528 */     MCD::OPC_ExtractField, 26, 1,  // Inst{26} ...
/* 531 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 545
/* 535 */     MCD::OPC_CheckField, 10, 6, 60, 234, 1, // Skip to: 1031
/* 541 */     MCD::OPC_Decode, 181, 3, 27, // Opcode: LDC_lru6
/* 545 */     MCD::OPC_FilterValue, 1, 226, 1, // Skip to: 1031
/* 549 */     MCD::OPC_CheckField, 10, 6, 60, 220, 1, // Skip to: 1031
/* 555 */     MCD::OPC_Decode, 188, 3, 27, // Opcode: LDWCP_lru6
/* 559 */     MCD::OPC_FilterValue, 14, 103, 0, // Skip to: 666
/* 563 */     MCD::OPC_ExtractField, 26, 1,  // Inst{26} ...
/* 566 */     MCD::OPC_FilterValue, 0, 46, 0, // Skip to: 616
/* 570 */     MCD::OPC_ExtractField, 10, 6,  // Inst{15-10} ...
/* 573 */     MCD::OPC_FilterValue, 60, 198, 1, // Skip to: 1031
/* 577 */     MCD::OPC_ExtractField, 22, 4,  // Inst{25-22} ...
/* 580 */     MCD::OPC_FilterValue, 12, 4, 0, // Skip to: 588
/* 584 */     MCD::OPC_Decode, 219, 2, 28, // Opcode: BRFU_lu6
/* 588 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 596
/* 592 */     MCD::OPC_Decode, 202, 2, 28, // Opcode: BLAT_lu6
/* 596 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 604
/* 600 */     MCD::OPC_Decode, 252, 2, 28, // Opcode: EXTDP_lu6
/* 604 */     MCD::OPC_FilterValue, 15, 4, 0, // Skip to: 612
/* 608 */     MCD::OPC_Decode, 154, 3, 28, // Opcode: KCALL_lu6
/* 612 */     MCD::OPC_Decode, 217, 2, 29, // Opcode: BRFT_lru6
/* 616 */     MCD::OPC_FilterValue, 1, 155, 1, // Skip to: 1031
/* 620 */     MCD::OPC_ExtractField, 10, 6,  // Inst{15-10} ...
/* 623 */     MCD::OPC_FilterValue, 60, 148, 1, // Skip to: 1031
/* 627 */     MCD::OPC_ExtractField, 22, 4,  // Inst{25-22} ...
/* 630 */     MCD::OPC_FilterValue, 12, 4, 0, // Skip to: 638
/* 634 */     MCD::OPC_Decode, 213, 2, 30, // Opcode: BRBU_lu6
/* 638 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 646
/* 642 */     MCD::OPC_Decode, 248, 2, 28, // Opcode: ENTSP_lu6
/* 646 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 654
/* 650 */     MCD::OPC_Decode, 254, 2, 28, // Opcode: EXTSP_lu6
/* 654 */     MCD::OPC_FilterValue, 15, 4, 0, // Skip to: 662
/* 658 */     MCD::OPC_Decode, 221, 3, 28, // Opcode: RETSP_lu6
/* 662 */     MCD::OPC_Decode, 211, 2, 31, // Opcode: BRBT_lru6
/* 666 */     MCD::OPC_FilterValue, 15, 87, 0, // Skip to: 757
/* 670 */     MCD::OPC_ExtractField, 26, 1,  // Inst{26} ...
/* 673 */     MCD::OPC_FilterValue, 0, 46, 0, // Skip to: 723
/* 677 */     MCD::OPC_ExtractField, 10, 6,  // Inst{15-10} ...
/* 680 */     MCD::OPC_FilterValue, 60, 91, 1, // Skip to: 1031
/* 684 */     MCD::OPC_ExtractField, 22, 4,  // Inst{25-22} ...
/* 687 */     MCD::OPC_FilterValue, 12, 4, 0, // Skip to: 695
/* 691 */     MCD::OPC_Decode, 229, 2, 28, // Opcode: CLRSR_lu6
/* 695 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 703
/* 699 */     MCD::OPC_Decode, 240, 3, 28, // Opcode: SETSR_lu6
/* 703 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 711
/* 707 */     MCD::OPC_Decode, 156, 3, 28, // Opcode: KENTSP_lu6
/* 711 */     MCD::OPC_FilterValue, 15, 4, 0, // Skip to: 719
/* 715 */     MCD::OPC_Decode, 158, 3, 28, // Opcode: KRESTSP_lu6
/* 719 */     MCD::OPC_Decode, 215, 2, 29, // Opcode: BRFF_lru6
/* 723 */     MCD::OPC_FilterValue, 1, 48, 1, // Skip to: 1031
/* 727 */     MCD::OPC_ExtractField, 10, 6,  // Inst{15-10} ...
/* 730 */     MCD::OPC_FilterValue, 60, 41, 1, // Skip to: 1031
/* 734 */     MCD::OPC_ExtractField, 22, 4,  // Inst{25-22} ...
/* 737 */     MCD::OPC_FilterValue, 12, 4, 0, // Skip to: 745
/* 741 */     MCD::OPC_Decode, 139, 3, 28, // Opcode: GETSR_lu6
/* 745 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 753
/* 749 */     MCD::OPC_Decode, 173, 3, 28, // Opcode: LDAWCP_lu6
/* 753 */     MCD::OPC_Decode, 209, 2, 31, // Opcode: BRBF_lru6
/* 757 */     MCD::OPC_FilterValue, 16, 12, 0, // Skip to: 773
/* 761 */     MCD::OPC_CheckField, 11, 16, 159, 251, 3, 6, 1, // Skip to: 1031
/* 769 */     MCD::OPC_Decode, 251, 3, 21, // Opcode: ST16_l3r
/* 773 */     MCD::OPC_FilterValue, 17, 12, 0, // Skip to: 789
/* 777 */     MCD::OPC_CheckField, 11, 16, 159, 251, 3, 246, 0, // Skip to: 1031
/* 785 */     MCD::OPC_Decode, 252, 3, 21, // Opcode: ST8_l3r
/* 789 */     MCD::OPC_FilterValue, 18, 33, 0, // Skip to: 826
/* 793 */     MCD::OPC_ExtractField, 11, 16,  // Inst{26-11} ...
/* 796 */     MCD::OPC_FilterValue, 159, 251, 3, 4, 0, // Skip to: 806
/* 802 */     MCD::OPC_Decode, 196, 2, 32, // Opcode: ASHR_l2rus
/* 806 */     MCD::OPC_FilterValue, 191, 251, 3, 4, 0, // Skip to: 816
/* 812 */     MCD::OPC_Decode, 214, 3, 32, // Opcode: OUTPW_l2rus
/* 816 */     MCD::OPC_FilterValue, 223, 251, 3, 209, 0, // Skip to: 1031
/* 822 */     MCD::OPC_Decode, 149, 3, 32, // Opcode: INPW_l2rus
/* 826 */     MCD::OPC_FilterValue, 19, 12, 0, // Skip to: 842
/* 830 */     MCD::OPC_CheckField, 11, 16, 159, 251, 3, 193, 0, // Skip to: 1031
/* 838 */     MCD::OPC_Decode, 177, 3, 33, // Opcode: LDAWF_l2rus
/* 842 */     MCD::OPC_FilterValue, 20, 12, 0, // Skip to: 858
/* 846 */     MCD::OPC_CheckField, 11, 16, 159, 251, 3, 177, 0, // Skip to: 1031
/* 854 */     MCD::OPC_Decode, 171, 3, 33, // Opcode: LDAWB_l2rus
/* 858 */     MCD::OPC_FilterValue, 21, 12, 0, // Skip to: 874
/* 862 */     MCD::OPC_CheckField, 11, 16, 159, 251, 3, 161, 0, // Skip to: 1031
/* 870 */     MCD::OPC_Decode, 233, 2, 34, // Opcode: CRC_l3r
/* 874 */     MCD::OPC_FilterValue, 24, 12, 0, // Skip to: 890
/* 878 */     MCD::OPC_CheckField, 11, 16, 159, 251, 3, 145, 0, // Skip to: 1031
/* 886 */     MCD::OPC_Decode, 219, 3, 21, // Opcode: REMS_l3r
/* 890 */     MCD::OPC_FilterValue, 25, 12, 0, // Skip to: 906
/* 894 */     MCD::OPC_CheckField, 11, 16, 159, 251, 3, 129, 0, // Skip to: 1031
/* 902 */     MCD::OPC_Decode, 220, 3, 21, // Opcode: REMU_l3r
/* 906 */     MCD::OPC_FilterValue, 26, 31, 0, // Skip to: 941
/* 910 */     MCD::OPC_ExtractField, 26, 1,  // Inst{26} ...
/* 913 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 927
/* 917 */     MCD::OPC_CheckField, 10, 6, 60, 108, 0, // Skip to: 1031
/* 923 */     MCD::OPC_Decode, 207, 2, 35, // Opcode: BLRF_lu10
/* 927 */     MCD::OPC_FilterValue, 1, 100, 0, // Skip to: 1031
/* 931 */     MCD::OPC_CheckField, 10, 6, 60, 94, 0, // Skip to: 1031
/* 937 */     MCD::OPC_Decode, 205, 2, 36, // Opcode: BLRB_lu10
/* 941 */     MCD::OPC_FilterValue, 27, 31, 0, // Skip to: 976
/* 945 */     MCD::OPC_ExtractField, 26, 1,  // Inst{26} ...
/* 948 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 962
/* 952 */     MCD::OPC_CheckField, 10, 6, 60, 73, 0, // Skip to: 1031
/* 958 */     MCD::OPC_Decode, 168, 3, 35, // Opcode: LDAPF_lu10
/* 962 */     MCD::OPC_FilterValue, 1, 65, 0, // Skip to: 1031
/* 966 */     MCD::OPC_CheckField, 10, 6, 60, 59, 0, // Skip to: 1031
/* 972 */     MCD::OPC_Decode, 166, 3, 36, // Opcode: LDAPB_lu10
/* 976 */     MCD::OPC_FilterValue, 28, 31, 0, // Skip to: 1011
/* 980 */     MCD::OPC_ExtractField, 26, 1,  // Inst{26} ...
/* 983 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 997
/* 987 */     MCD::OPC_CheckField, 10, 6, 60, 38, 0, // Skip to: 1031
/* 993 */     MCD::OPC_Decode, 200, 2, 35, // Opcode: BLACP_lu10
/* 997 */     MCD::OPC_FilterValue, 1, 30, 0, // Skip to: 1031
/* 1001 */    MCD::OPC_CheckField, 10, 6, 60, 24, 0, // Skip to: 1031
/* 1007 */    MCD::OPC_Decode, 189, 3, 35, // Opcode: LDWCP_lu10
/* 1011 */    MCD::OPC_FilterValue, 29, 16, 0, // Skip to: 1031
/* 1015 */    MCD::OPC_CheckField, 26, 1, 0, 10, 0, // Skip to: 1031
/* 1021 */    MCD::OPC_CheckField, 10, 6, 60, 4, 0, // Skip to: 1031
/* 1027 */    MCD::OPC_Decode, 226, 3, 29, // Opcode: SETC_lru6
/* 1031 */    MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  llvm_unreachable("Invalid index!");
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 2:
    if (!Check(S, Decode2RInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    if (!Check(S, Decode2RUSInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 4:
    if (!Check(S, DecodeR2RInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    if (!Check(S, Decode3RInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 6:
    if (!Check(S, Decode2RImmInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    if (!Check(S, Decode2RSrcDstInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 8:
    if (!Check(S, DecodeRUSSrcDstBitpInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 9:
    if (!Check(S, DecodeRUSInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 6, 4);
    if (!Check(S, DecodeRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 6, 4);
    if (!Check(S, DecodeGRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 0, 6);
    if (!Check(S, DecodeNegImmOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 6, 4);
    if (!Check(S, DecodeGRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    if (!Check(S, DecodeNegImmOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 15:
    if (!Check(S, DecodeRUSBitpInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    if (!Check(S, Decode2RUSBitpInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 17:
    if (!Check(S, Decode3RImmInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 0, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 0, 10);
    if (!Check(S, DecodeNegImmOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 20:
    if (!Check(S, DecodeL2RInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 21:
    if (!Check(S, DecodeL3RInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    if (!Check(S, DecodeL4RSrcDstInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 23:
    if (!Check(S, DecodeL4RSrcDstSrcDstInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 24:
    if (!Check(S, DecodeL5RInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 25:
    if (!Check(S, DecodeL6RInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    if (!Check(S, DecodeLR2RInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 22, 4);
    if (!Check(S, DecodeRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 10), 6, 10);
    insertBits(tmp, fieldFromInstruction(insn, 16, 6), 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 28:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 10), 6, 10);
    insertBits(tmp, fieldFromInstruction(insn, 16, 6), 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 22, 4);
    if (!Check(S, DecodeGRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 10), 6, 10);
    insertBits(tmp, fieldFromInstruction(insn, 16, 6), 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 30:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 10), 6, 10);
    insertBits(tmp, fieldFromInstruction(insn, 16, 6), 0, 6);
    if (!Check(S, DecodeNegImmOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 22, 4);
    if (!Check(S, DecodeGRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 10), 6, 10);
    insertBits(tmp, fieldFromInstruction(insn, 16, 6), 0, 6);
    if (!Check(S, DecodeNegImmOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    if (!Check(S, DecodeL2RUSBitpInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    if (!Check(S, DecodeL2RUSInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    if (!Check(S, DecodeL3RSrcDstInstruction(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 35:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 10), 10, 10);
    insertBits(tmp, fieldFromInstruction(insn, 16, 10), 0, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 36:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 10), 10, 10);
    insertBits(tmp, fieldFromInstruction(insn, 16, 10), 0, 10);
    if (!Check(S, DecodeNegImmOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

static unsigned decodeNumToSkip(const uint8_t *&Ptr) {
  unsigned NumToSkip = *Ptr++;
  NumToSkip |= (*Ptr++) << 8;
  return NumToSkip;
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr++) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr++;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      uint64_t Val = decodeULEB128AndIncUnsafe(Ptr);
      bool Failed = Val != CurFieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the filter operation.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << (Failed ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      bool Failed = ExpectedValue != FieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // If the actual and expected values don't match, skip.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << (Failed ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);
      // Check the predicate.
      bool Failed = !checkDecoderPredicate(PIdx, Bits);
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Failed ? "FAIL\n" : "PASS\n"));

      break;
    }
    case MCD::OPC_Decode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      uint64_t PositiveMask = decodeULEB128AndIncUnsafe(Ptr);
      uint64_t NegativeMask = decodeULEB128AndIncUnsafe(Ptr);
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // namespace
